<!-- 设备台账公共模板 -->
<script lang="ts" setup>
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { fixedAssetsParams, fixedAssetsType, selectType } from '../standingBook-interface'
import { printJSON } from '@/utils/printUtils'
import { getDictByCode } from '@/api/system/dict'
import { uploadApi } from '@/api/system/notice'
import { getDeptTreeList } from '@/api/system/dept'
import { toTreeList } from '@/utils/structure'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { assetsDeleteApi, listExportApi, listPageApi } from '@/api/device/standingBook'
import { exportFile } from '@/utils/exportUtils'
const props = defineProps({
  /**
   * 页面名称
   */
  name: {
    type: String,
    default: '',
  },
  // 权限
  authority: {
    type: String,
    required: true,
  },
  // 是否测量设备
  equipmentCategory: {
    type: String,
    default: '',
  },
  // 是否固定资产
  isFixedAssets: {
    type: String,
    default: '',
  },
  // 是否是技术指标需要校准检定的设备
  isCalibrationTestEquipment: {
    type: String,
    default: '',
  },
  // 是否是技术指标需要校准检定的设备
  isMeasureAccount: {
    type: String,
    default: '',
  },
  // 是否是技术指标需要校准检定的设备
  isStandardSupportEquipment: {
    type: String,
    default: '',
  },
})
const $router = useRouter()
const { proxy } = getCurrentInstance() as any
const validDate = ref()
const searchQuery: fixedAssetsParams = reactive({
  equipmentNo: '', // 设备编号
  equipmentName: '', // 名称
  mesureType: '', // 检定方式
  managerState: '', // 管理状态
  useDept: '', // 使用部门
  assetType: '', // 资产类型
  equipmentCategory: '', // 测量设备
  isCalibrationTestEquipment: '', // 校准/检定设备
  isMeasureAccount: '', // 测量工装
  isStandardSupportEquipment: '', // 标准配套设备
  isFixedAssets: '', // 固定资产
  validStartDate: '', // 有效开始日期
  validEndDate: '', // 有效结束日期
  abc: null,
  limit: 20,
  offset: 1,
  ids: [] as string[],
}) // 查询参数
watch(() => searchQuery.abc, (newVal) => {
  if (!newVal) {
    searchQuery.abc = null
  }
})
watch(() => validDate.value, (newVal) => {
  if (newVal) {
    searchQuery.validStartDate = newVal[0]
    searchQuery.validEndDate = newVal[1]
  }
  else {
    searchQuery.validStartDate = ''
    searchQuery.validEndDate = ''
  }
})
const loadingTable = ref<boolean>(false) // 表格loading
const total = ref<number>(0) // 数据总条数
const columns = ref<TableColumn[]>([
  { text: '设备编号', value: 'equipmentNo', align: 'center', width: 160 },
  { text: '名称', value: 'equipmentName', align: 'center' },
  { text: '型号', value: 'modelNo', align: 'center' },
  { text: 'ABC', value: 'abc', align: 'center', width: 58 },
  { text: '检定方式', value: 'mesureTypeName', align: 'center', width: 90 },
  { text: '管理状态', value: 'managerStateName', align: 'center', width: 100 },
  { text: '使用部门', value: 'useDeptName', align: 'center' },
  { text: '使用人', value: 'usePersonName', align: 'center' },
  { text: '有效日期', value: 'validDate', align: 'center', width: 165 },
  { text: '备注', value: 'remark', align: 'center' },
])

const list = ref<fixedAssetsType[]>([]) // 表格数据

// 获取数据
const useDeptList = ref([])
const mesureTypeList = ref<selectType[]>([])
const managerStateList = ref<selectType[]>([])
const abcList = ref<selectType[]>([])
const fetchData = () => {
  // 获取使用部门
  getDeptTreeList().then((res) => {
    if (res.data) { // 将列表转树结构
      useDeptList.value = toTreeList(res.data, '0', true)
    }
  })
  // 获取检定方式
  getDictByCode('mesureType').then((response) => {
    mesureTypeList.value = response.data
  })
  // 获取管理状态
  getDictByCode('managerState').then((response) => {
    managerStateList.value = response.data
  })
  // 获取ABC
  getDictByCode('ABC').then((response) => {
    abcList.value = response.data
  })
}
// 获取数据列表
const getList = () => {
  loadingTable.value = true
  searchQuery.isCalibrationTestEquipment = props.isCalibrationTestEquipment
  searchQuery.isMeasureAccount = props.isMeasureAccount
  searchQuery.isStandardSupportEquipment = props.isStandardSupportEquipment
  if (props.name === '测量设备') {
    searchQuery.equipmentCategory = '1'
  }
  listPageApi(searchQuery).then((res) => {
    if (res.code === 200) {
      list.value = res.data.rows
      total.value = res.data.total
    }
    loadingTable.value = false
  }).catch((_) => {
    loadingTable.value = false
  })
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.limit = val.size
  }
  if (val && val.page) {
    searchQuery.offset = val.page
  }
  getList()
}
// 详情
const detail = (row: fixedAssetsType) => {
  $router.push({
    name: 'standingBookDetail',
    params: { type: 'detail' },
    query: { title: '详情', name: props.name, id: row.id },
  })
}
// 编辑
const update = (row: fixedAssetsType) => {
  $router.push({
    name: 'standingBookDetail',
    params: { type: 'edit' },
    query: { title: '编辑', name: props.name, id: row.id },
  })
}
// 删除
const remove = (row: fixedAssetsType) => {
  ElMessageBox.confirm(
    `确认删除${row.equipmentName}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      assetsDeleteApi({ id: row.id }).then((res) => {
        if (res.code === 200) {
          ElMessage.success('删除成功')
          getList()
        }
      })
    })
}
// 搜索
const search = () => {
  getList()
}
// 重置
const reset = () => {
  // searchQuery.fileNo = ''
  validDate.value = ''
  getList()
}
// 模板下载
const templateDownload = () => {

}

// 新增
const add = () => {
  $router.push({
    name: 'standingBookDetail',
    params: {
      type: 'add',
    },
    query: {
      title: '新建',
      name: props.name,
    },
  })
}
// 标签识别
const identify = () => {

}
// 表格被选中的行
const selectList = ref<fixedAssetsType[]>([])
// 表格多选
const multiSelect = (row: fixedAssetsType[]) => {
  selectList.value = row
}

// 打印列表
function printList() {
  const selectIds: string[] = selectList.value.map((item: fixedAssetsType) => item.id)
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (selectIds.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, props.name)
  }
  else if (selectIds.length > 0) {
    const printList = list.value.filter((item: fixedAssetsType) => selectIds.includes(item.id))
    printJSON(printList, properties, props.name)
  }
  else {
    ElMessage('无可打印内容')
  }
}
// 导出
const exportExcelBtn = () => {
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  const selectIds: string[] = selectList.value.map((item: fixedAssetsType) => item.id)
  if (list.value.length > 0) {
    const params = { ...searchQuery, ids: selectIds }
    listExportApi(params).then((res) => {
      const blob = new Blob([res.data])
      exportFile(blob, `${props.name}.xlsx`)
      loading.close()
    }).catch((_) => {
      loading.close()
    })
  }
  else {
    ElMessage.warning('无数据可导出数据')
  }
}
const fileRef = ref() // 文件上传input
const onFileChange = (event: any) => {
  // 原生上传
  // console.log(event.target.files)
  // if (event.target.files[0].type === 'application/pdf') {
  if (event.target.files?.length !== 0) {
    // 创建formdata对象
    const fd = new FormData()
    fd.append('multipartFile', event.target.files[0])
    uploadApi(fd).then((res) => {
      if (res.code === 200) {
        ElMessage.success('上传成功')
      }
      else {
        ElMessage.error(res.message)
      }
    })
  }
//   }
//   else {
//     ElMessage.error('请上传pdf格式')
//   }
}
// 批量导入
const batchImport = () => {
  fileRef.value.click()
}
onMounted(() => {
  getList()
  fetchData()
})
</script>

<template>
  <div>
    <!-- 布局 -->
    <app-container>
      <!-- 筛选条件 -->
      <search-area :need-clear="true" @search="search" @clear="reset">
        <search-item>
          <el-input v-model="searchQuery.equipmentNo" placeholder="设备编号" clearable class="w-50 m-2" style="width: 185px;" />
        </search-item>
        <search-item>
          <el-input v-model="searchQuery.equipmentName" placeholder="名称" clearable class="w-50 m-2" style="width: 185px;" />
        </search-item>
        <search-item>
          <el-select v-model="searchQuery.mesureType" class="m-2" placeholder="检定方式" clearable style="width: 185px;">
            <el-option
              v-for="item in mesureTypeList"
              :key="item.id"
              :label="item.name"
              :value="item.value"
            />
          </el-select>
        </search-item>
        <search-item>
          <el-select v-model="searchQuery.managerState" class="m-2" placeholder="管理状态" clearable style="width: 185px;">
            <el-option
              v-for="item in managerStateList"
              :key="item.id"
              :label="item.name"
              :value="item.value"
            />
          </el-select>
        </search-item>
        <search-item>
          <dept-select v-model="searchQuery.useDept" :data="useDeptList" placeholder="使用部门" style="width: 185px;" />
        </search-item>
        <search-item>
          <el-date-picker
            v-model="validDate"
            type="daterange"
            format="YYYY-MM-DD" value-format="YYYY-MM-DD HH:mm:ss"
            range-separator="至"
            start-placeholder="有效开始日期"
            end-placeholder="有效结束日期"
            clearable
            style="width: 360px;"
          />
        </search-item>
        <search-item>
          <el-select v-model="searchQuery.abc" class="m-2" placeholder="ABC" clearable style="width: 185px;">
            <el-option
              v-for="item in abcList"
              :key="item.id"
              :label="item.name"
              :value="item.value"
            />
          </el-select>
        </search-item>
      </search-area>
      <table-container>
        <!-- 表头区域 -->
        <template #btns-right>
          <input v-show="(searchQuery.limit === 0)" ref="fileRef" type="file" multiple @change="onFileChange">
          <icon-button v-if="proxy.hasPerm(`/device/${$props.authority}/add`)" icon="icon-add" title="新建" @click="add" />
          <icon-button v-if="proxy.hasPerm(`/device/${$props.authority}/identify`)" icon="icon-device" title="标签识别" @click="identify" />
          <icon-button v-if="proxy.hasPerm(`/device/${$props.authority}/import`)" icon="icon-import" title="批量导入" @click="batchImport" />
          <icon-button v-if="proxy.hasPerm(`/device/${$props.authority}/mould`)" icon="icon-template" title="模板下载" @click="templateDownload" />
          <icon-button v-if="proxy.hasPerm(`/device/${$props.authority}/export`)" icon="icon-export" title="导出" @click="exportExcelBtn" />
          <icon-button v-if="proxy.hasPerm(`/device/${$props.authority}/print`)" icon="icon-print" title="打印" @click="printList" />
        </template>
        <!-- 表格区域 -->
        <normal-table
          id="print"
          :data="list" :total="total" :columns="columns"
          :is-showmulti-select="true"
          :query="searchQuery"
          :list-loading="loadingTable"
          :is-multi="true"
          :options="{ needIndex: true }"
          @change="changePage" @multi-select="multiSelect"
        >
          <template #preColumns>
            <el-table-column label="序号" width="55" align="center">
              <template #default="scope">
                {{ (searchQuery.offset! - 1) * searchQuery.limit! + scope.$index + 1 }}
              </template>
            </el-table-column>
          </template>
          <template #columns>
            <el-table-column label="操作" align="center" width="120">
              <template #default="{ row }">
                <el-button v-if="proxy.hasPerm(`/device/${$props.authority}/update`)" size="small" type="primary" link @click="update(row)">
                  编辑
                </el-button>
                <el-button v-if="proxy.hasPerm(`/device/${$props.authority}/detail`)" size="small" type="primary" link @click="detail(row)">
                  详情
                </el-button>
                <el-button v-if="proxy.hasPerm(`/device/${$props.authority}/delete`)" size="small" type="danger" link @click="remove(row)">
                  删除
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
    </app-container>
  </div>
</template>

